//Import de PAlib
#include <PA9.h>

#include "MUSIC_Highscores.h"

#include "highscores.h"

void voirHighscoresSimpleClic(void)
{
   PA_Init2D();
 
   PA_InitText(0, 2);
   
   PA_PlaySimpleSound(0, MUSIC_Highscores);
   
   bool clic = 0, soundFini = 0;
   
   u32 score[10] = {0};
   recupHighScores(score);
   
   char text[100] = "";
         
	fadeOut(2);
	
   PA_LoadTiledBg(1, 3, bg_up_highscores);	
   PA_LoadTiledBg(0, 3, bg_down_highscores);
   
   PA_Init16cBg(1, 2);
   PA_16cText(1, 70, 145, 186, 170, "SIMPLE CLIC", 10, 2, 100);
   
   PA_Init16cBg(0, 2);
   sprintf(text, " [1] : %d ", score[0]);
   PA_16cText(0, 80, 50, 180, 65, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[1]);
   PA_16cText(0, 80, 70, 180, 85, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[2]);
   PA_16cText(0, 80, 90, 180, 105, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[3]);
   PA_16cText(0, 80, 110, 180, 125, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[4]);
   PA_16cText(0, 80, 130, 180, 145, text, 10, 3, 100);
   
   fadeIn(2);	
 
   while(1)
   {
      if(Stylus.Released) { clic = 1; }   
		      
      if(PA_StylusInZone(0, 0, 69, 20) && clic) { clic = 0; PA_StopSound(0); soundFini = 1; menuHighscores();  }	
 		
 		if(PA_SoundChannelIsBusy(0) && !soundFini) { PA_PlaySimpleSound(0, MUSIC_Highscores); }
		PA_WaitForVBL();  	
   } 	
	PA_WaitForVBL();  	
}

void voirHighscoresMicroClic(void)
{
   PA_Init2D();
 
   PA_InitText(0, 2);
   
   PA_PlaySimpleSound(0, MUSIC_Highscores);
   
   bool clic = 0, soundFini = 0;
   
   u32 score[10] = {0};
 	recupHighScores(score);
 	
 	char text[100] = "";
         
	fadeOut(2);
	
   PA_LoadTiledBg(1, 3, bg_up_highscores);	
   PA_LoadTiledBg(0, 3, bg_down_highscores);
   
   PA_Init16cBg(1, 2);
   PA_16cText(1, 70, 145, 186, 170, "MICRO CLIC", 10, 2, 100);
   
   PA_Init16cBg(0, 2);
   sprintf(text, " [1] : %d ", score[5]);
   PA_16cText(0, 80, 50, 180, 65, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[6]);
   PA_16cText(0, 80, 70, 180, 85, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[7]);
   PA_16cText(0, 80, 90, 180, 105, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[8]);
   PA_16cText(0, 80, 110, 180, 125, text, 10, 3, 100);
   sprintf(text, " [1] : %d ", score[9]);
   PA_16cText(0, 80, 130, 180, 145, text, 10, 3, 100);
   
   		
   fadeIn(2);	
 
   while(1)
   {
      if(Stylus.Released) { clic = 1; }   
		      
      if(PA_StylusInZone(0, 0, 69, 20) && clic) { clic = 0; PA_StopSound(0); soundFini = 1; menuHighscores(); }	
 		
 		if(PA_SoundChannelIsBusy(0) && !soundFini) { PA_PlaySimpleSound(0, MUSIC_Highscores); }
		PA_WaitForVBL();  	
   } 	
	PA_WaitForVBL();  	
}  
   
void recupHighScores(u32 *score)
{
   FILE *fichier = NULL;
	fichier = fopen("/ClickOnDS.sav", "r"); //On ouvre le fichier en mode lecture
	 
	//Si l'ouverture a fonctionne
	if (fichier != NULL)
	{
	   //On prend les valeurs des HighScores
	   fscanf(fichier, "%d %d %d %d %d\r\n%d %d %d %d %d", &score[0], &score[1], &score[2],  &score[3],  &score[4], &score[5], &score[6], &score[7],  &score[8],  &score[9]);
	   fclose(fichier); //On ferme le fichier
	}
	//Si l'ouverture n'a pas fonctionne
	else
	{
	   // On affiche un message d'erreur
	   fprintf(stderr, "Erreur Fichier: Ouverture du fichier choue lors de la rcupration des HighScores");
	}  
} 
 
void sauverHighScores(u8 clics, u8 jeu)
{
	FILE* fichier = NULL;
	s32 score[10] = {0}; // Tableau des 5 meilleurs scores
	char texteAffiche[100] = "";
	 
	fichier = fopen("/ClickOnDS.sav", "r+"); //On ouvre le fichier en mode lecture + criture
	 
	//Si l'ouverture a fonctionne
	if (fichier != NULL)
	{
	   //On prend les anciennes valeurs des HighScores
	   fscanf(fichier, "%d %d %d %d %d\n%d %d %d %d %d", &score[0], &score[1], &score[2],  &score[3],  &score[4], &score[5], &score[6], &score[7],  &score[8],  &score[9]);
	 
	   if(jeu == 10)
	   {
	      if (clics > score[0])
	      {
	         //PREMIER !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", clics, score[0], score[1], score[2], score[3], score[5], score[6], score[7], score[8], score[9]); //Enregistrement des HighScores
	         fwrite(texteAffiche, 100, 1, fichier);
	            
	      }
	      else if (clics > score[1] && clics < score[0])
	      {
	         //DEUXIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], clics, score[1], score[2], score[3], score[5], score[6], score[7], score[8], score[9]); //Enregistrement des HighScores
	         fwrite(texteAffiche, 100, 1, fichier);
	      }
	        else if (clics > score[2] && clics < score[1])
	      {
	         //TROSIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], clics, score[2], score[3], score[5], score[6], score[7], score[8], score[9]); //Enregistrement des HighScores
	         fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics > score[3] && clics < score[2])
	      {
	         //QUATRIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], clics, score[3], score[5], score[6], score[7], score[8], score[9]); //Enregistrement des HighScores
	         fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics < score[3])
	      {
	         //CINQUIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], clics, score[5], score[6], score[7], score[8], score[9]); //Enregistrement des HighScores
	         fwrite(texteAffiche, 100, 1, fichier);
	      }
		}
	 
	   else if(jeu == 11)
	   {
	      if (clics > score[5])
	      {
	         //PREMIER !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], score[4], clics, score[5], score[6], score[7], score[8]); //Enregistrement des HighScores
	        	fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics > score[6] && clics < score[5])
	      {
	           //DEUXIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], score[4], score[5], clics, score[6], score[7], score[8]); //Enregistrement des HighScores
	        	fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics > score[7] && clics < score[6])
	      {
	         //TROSIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], score[4], score[5], score[6], clics, score[7], score[8]); //Enregistrement des HighScores
	        	fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics > score[8] && clics < score[7])
	      {
	         //QUATRIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], score[4], score[5], score[6], score[7], clics, score[8]); //Enregistrement des HighScores
	        	fwrite(texteAffiche, 100, 1, fichier);
	      }
	      else if (clics < score[8])
	      {
	         //CINQUIEME !
	         rewind(fichier);
	         sprintf(texteAffiche, "%d %d %d %d %d\n%d %d %d %d %d", score[0], score[1], score[2], score[3], score[4], score[5], score[6], score[7], score[8], clics); //Enregistrement des HighScores
	        	fwrite(texteAffiche, 100, 1, fichier);
	      }
	   }
	 
	   fclose(fichier); //On ferme le fichier
	}
	  //Si l'ouverture n'a pas fonctionne
	else
	{
	   // On affiche un message d'erreur
	   PA_OutputSimpleText(1, 0, 10, "Fichier: Ouverture du fichier choue lors de la sauvegarde des HighScores");
	}  
}
 
 
 
