//Import de PAlib
#include <PA9.h>

#include "MUSIC_Jeu.h"
#include "SFX_FinJeu.h"

#include "jeu.h"

void jouerSimpleClic(void)
{
   PA_Init2D(); //On efface tout
   
   PA_PlaySimpleSound(0, MUSIC_Jeu);
   
   bool clic = 0, start = 0, soundFini = 0, finSoundJeu = 0;
 
   fadeOut(2);
         
   PA_LoadTiledBg(1, 3, bg_up_jeu);	
   PA_LoadTiledBg(0, 3, bg_down);
   
   PA_Init16cBg(1, 2);
   PA_16cText(1, 70, 145, 186, 170, "SIMPLE CLIC", 10, 3, 100);
   
   fadeIn(2);
 
	s32 tempsJeu = TEMPS_JEU;
	u32 compteurclicks = 0;
 	u8 jeuDoing = JEU_SIMPLE_CLIC;
 	char text[100] = "";
 
   while(1)
   {
      PA_16cText(1, 70, 145, 186, 170, "SIMPLE CLIC", 10, 3, 100);
      
      if(start)
      {
	   	if(Stylus.Released) { clic = 1; }   
			
			if(!PA_SoundChannelIsBusy(1)) 
			{ 
			   if(PA_StylusInZone(0, 0, 69, 20) && clic) 
				{ 
				   clic = 0; 
					PA_StopSound(0); 
					soundFini = 1; 
					menuJeu(); 
				} 
			}
			else 
			{
				if(PA_StylusInZone(0, 0, 69, 20) && clic) 
				{ 
				   clic = 0; 
					PA_StopSound(0); 
					PA_StopSound(1); 
					soundFini = 1; 
					menuJeu(); 
				}
			}
			 
	      if(Stylus.Released && tempsJeu > 0)
	      {
	      	compteurclicks++;
	      }
	
	      sprintf(text, "Score : %d  ", compteurclicks);
	      PA_16cText(1, 199, 176, 254, 190, text, 10, 1, 100);
	 				
	 		if(tempsJeu > 0)
	 		{
	 			tempsJeu--;
	 			sprintf(text, " Temps : %d ", tempsJeu);
	 			PA_16cText(1, 0, 176, 56, 190, text, 10, 1, 100);
	 		}			
			else if(tempsJeu <= 0) //C'est fini !
			{
			   if(!finSoundJeu) { PA_PlaySimpleSound(1, SFX_FinJeu); finSoundJeu = 1; }
				PA_16cText(1, 0, 176, 56, 190, " FINISH !!!", 10, 1, 100);
				sauverHighScores(compteurclicks, jeuDoing);
			}			
		}					
		else
		{
		   if(Stylus.Released) { clic = 1; }        
	      if(PA_StylusInZone(0, 0, 69, 20) && clic) { clic = 0; PA_StopSound(0); soundFini = 1; menuJeu(); }
	      
		   if(Stylus.Released) { start = 1; }	
		   
		   PA_16cText(1, 80, 160, 186, 170, "Touch to start !", 10, 2, 100);	
		}
		PA_WaitForVBL(); 
		PA_16cErase(1); 
		if(PA_SoundChannelIsBusy(0) && !soundFini) { PA_PlaySimpleSound(0, MUSIC_Jeu); }
   } 
   PA_WaitForVBL();  
}

void jouerMicroClic(void)
{
   PA_Init2D();
   
   PA_PlaySimpleSound(0, MUSIC_Jeu);
   
   bool clic = 0, start = 0, soundFini = 0, finSoundJeu = 0;
 
   fadeOut(2);
         
   PA_LoadTiledBg(1, 3, bg_up_jeu);	
   PA_LoadTiledBg(0, 3, bg_down);
   
   PA_Init16cBg(1, 2); PA_Init16cBg(0, 2);
   PA_16cText(1, 70, 145, 186, 170, "MICRO CLIC", 10, 3, 100);
   
   fadeIn(2);
 
	s32 tempsJeu = TEMPS_JEU;
	u32 compteurclicks = 0;
 	u8 jeuDoing = JEU_MICRO_CLIC;
 	char text[100] = "";
 	
 
   while(1)
   {
	   PA_16cText(1, 70, 145, 186, 170, "MICRO CLIC", 10, 3, 100);
		      		
		if(start)
		{  
	   	if(Stylus.Released) { clic = 1; }   
			      
			if(!PA_SoundChannelIsBusy(1)) 
			{ 
			   if(PA_StylusInZone(0, 0, 69, 20) && clic) 
				{ 
				   clic = 0; 
					PA_StopSound(0); 
					soundFini = 1; 
					menuJeu(); 
				} 
			}
			else 
			{
				if(PA_StylusInZone(0, 0, 69, 20) && clic) 
				{ 
				   clic = 0; 
					PA_StopSound(0); 
					PA_StopSound(1); 
					soundFini = 1; 
					menuJeu(); 
				}
			}
			
	      if(Stylus.Released && PA_MicGetVol() >= 128 && tempsJeu > 0)
	      {
	      	compteurclicks++;
	      }
	 		
	      sprintf(text, "Score : %d  ", compteurclicks);
	      PA_16cText(1, 199, 176, 254, 190, text, 10, 1, 100);
	 				
	 		if(tempsJeu > 0)
	 		{
	 			tempsJeu--;
	 			sprintf(text, " Temps : %d ", tempsJeu);
	 			PA_16cText(1, 0, 176, 56, 190, text, 10, 1, 100);
	 		}			
			else if(tempsJeu <= 0) //C'est Fini !
			{
			   if(!finSoundJeu) { PA_PlaySimpleSound(1, SFX_FinJeu); finSoundJeu = 1; }
				PA_16cText(1, 1, 176, 56, 190, " FINISH !!!", 10, 1, 100);
				sauverHighScores(compteurclicks, jeuDoing);
			} 
			
			sprintf(text, "Volume Microphone : %d     ", PA_MicGetVol());
			PA_16cText(0, 2, 12, 100, 24, text, 10, 1, 100);
				
		}
		else
		{
		   if(Stylus.Released) { clic = 1; }        
	      if(PA_StylusInZone(0, 0, 69, 20) && clic) { clic = 0; PA_StopSound(0); menuJeu(); }
	      
		   if(Stylus.Released) { start = 1; }	
		   
		   PA_16cText(1, 80, 160, 186, 170, "Touch to start !", 10, 2, 100);	
		}   
		
		PA_WaitForVBL();  
		PA_16cErase(1); PA_16cErase(0); 
		if(PA_SoundChannelIsBusy(0) && !soundFini) { PA_PlaySimpleSound(0, MUSIC_Jeu); }
   } 

   PA_WaitForVBL();  
}
